$(document).ready(function() {

  // $('#calendar').fullCalendar({
  //   header: {
  //     left: 'prev,next today',
  //     center: 'title',
  //     right: 'month,agendaWeek,agendaDay,listWeek'
  //   },
  //   defaultDate: Date(),
  //   navLinks: true, // can click day/week names to navigate views
  //   weekNumbers: true,
  //   weekNumbersWithinDays: true,
  //   weekNumberCalculation: 'ISO',
  //   editable: true,
  //   allDay: true,
  //   events:[ {
  //   title: 'Default Event',
  //       start: '2018-08-07',
  //       end: '2018-08-10'
  //   }],
  //   eventLimit: true, // allow "more" link when too many events
  //   eventDrop: function(event, delta, revertFunc) {
  //     $('#start_date').val(event.start.format());
  //   }
  // });

  var initialLocaleCode = 'en';
  var now = new Date().setMinutes(0);

  $('.datetimepick').datetimepicker({
    format:'Y-m-d H:i',
  });

  $('#fullcalendar_scheduler').fullCalendar({
    schedulerLicenseKey: 'CC-Attribution-NonCommercial-NoDerivatives',
    now: now,
    editable: true, // enable draggable events
    aspectRatio: 1.8, // default: 1.35
    scrollTime: '00:00', // undo default 6am scrollTime
    header: {
      left: 'promptCourse,promptTrainer,promptRoom today prev,next',
      center: 'title',
      right: 'timeline1Day,timeline2Days,timeline3Days,timeline4Days,timeline5Days,timeline1Week,timeline2Weeks,timeline1Month,timeline3Months,timeline6Months,timeline1Year'
    },
    customButtons: {
      promptCourse: {
        text: '+Course',
        click: function() {
          var title = prompt('Course name');
          if (title) {
            $('#fullcalendar_scheduler').fullCalendar(
              'addResource',
              { title: title },
              true // scroll to the new resource?
            );
          }
        }
      },
      promptTrainer: {
        text: '+Trainer',
        click: function() {
          var title = prompt('Trainer name');
          if (title) {
            $('#fullcalendar_scheduler').fullCalendar(
              'addResource',
              { title: title },
              true // scroll to the new resource?
            );
          }
        }
      },
      promptRoom: {
        text: '+Room',
        click: function() {
          var title = prompt('Room name');
          if (title) {
            $('#fullcalendar_scheduler').fullCalendar(
              'addResource',
              { title: title },
              true // scroll to the new resource?
            );
          }
        }
      }
    },
    defaultView: 'timeline1Day',
    views: {
      timeline1Day: {
        type: 'timeline',
        duration: { days: 1 },
      },
      timeline2Days: {
        type: 'timeline',
        duration: { days: 2 }
      },
      timeline3Days: {
        type: 'timeline',
        duration: { days: 3 }
      },
      timeline4Days: {
        type: 'timeline',
        duration: { days: 4 }
      },
      timeline5Days: {
        type: 'timeline',
        duration: { days: 5 }
      },
      timeline1Week: {
        type: 'timeline',
        duration: { weeks: 1 },
      },
      timeline2Weeks: {
        type: 'timeline',
        duration: { weeks: 2 },
      },
      timeline1Month: {
        type: 'timeline',
        duration: { month: 1 },
      },
      timeline3Months: {
        type: 'timeline',
        duration: { month: 3 },
      },
      timeline6Months: {
        type: 'timeline',
        duration: { month: 6 },
      },
      timeline1Year: {
        type: 'timeline',
        duration: { year: 1 },
      },
    },

    resourceAreaWidth: '20%',
    resourceGroupField: 'resourceType',

    // If refetchResourcesOnNavigate is set to true, the network request will
    // be made with additional parameters: the start/end date of the newly
    // visible window of time, as well as the calendar’s timezone
    //
    // example request: /resource_planner/resources.json?start=2017-12-01&end=2017-01-12&timezone=UTC
    refetchResourcesOnNavigate: true,
    resources: {
     url: '/resource_planner/resources.json',
     type: 'GET',
    },

    eventSources: [
      {
        // Active events
        url: '/resource_planner/resource_events.json',
        type: 'GET',
        error: function() {
          alert('there was an error while fetching active events!');
        },
        //color: 'yellow',
        //textColor: 'black',
      },
      {
        // Non-availability / Restrictions
        url: '/resource_planner/resource_restrictions.json',
        type: 'GET',
        error: function() {
          alert('there was an error while fetching event restrictions!');
        },
        color: 'grey',
        textColor: 'black',
      },
    ],

    // Callbacks
    resourceRender: function(resourceObj, labelTds, bodyTds) {

      labelTds.on('click', function() {
        unselected_background_color = 'rgba(0, 0, 0, 0)';
        resource_id = labelTds.parent().attr('data-resource-id');

        selected = (labelTds.css('background-color') != unselected_background_color);
        if(selected) {
          labelTds.css('background-color', unselected_background_color);
          bodyTds.css('background-color', unselected_background_color);
        } else {
          labelTds.css('background-color', 'blue');
          bodyTds.css('background-color', 'cyan');
        }
      });

      // labelTds.css('background', 'blue');
      // bodyTds.css('background', 'yellow');
      // resource_id = labelTds.parent().attr("data-resource-id");
      // labelTds.eq(0).find('.fc-cell-content')
      //   .append(
      //     $('<strong>('+resource_id+')</strong>')
      //     //$('<strong>(?)</strong>')
      //     //.popover({
      //     //  title: resourceObj.title,
      //     //  content: 'test!',
      //     //  trigger: 'hover',
      //     //  placement: 'bottom',
      //     //  container: 'body'
      //     //})
      //   );
    },

    viewRender: function(view, element) {
    },

    eventAfterAllRender: function (view) {
      renderHighlighterBar();
    },

    eventDrop: function(event, delta, revertFunc) {
      if (!confirm(event.title + " was changed to " + event.start.format() + "\nAre you sure about this change?")) {
        revertFunc();
      }
    },

  });

  // build the locale selector's options
  $.each($.fullCalendar.locales, function(localeCode) {
    $('#locale-selector').append(
      $('<option/>')
        .attr('value', localeCode)
        .prop('selected', localeCode == initialLocaleCode)
        .text(localeCode)
    );
  });

  setLocaleCode(initialLocaleCode);
  renderHighlighterBar();

  // when the selected option changes, dynamically change the calendar option
  $('#locale-selector').on('change', function() {
    if (this.value) {
      //$.datetimepicker.setLocale(this.value);
      //$('#fullcalendar_scheduler').fullCalendar('option', 'locale', this.value);
      setLocaleCode(this.value);
      renderHighlighterBar();
    }
  });

  $('.date-field').on('change', function() {
    renderHighlighterBar('date');
  });

  /* These two listeners should be kept in sync */
  $('#duration').on('change', function() {
    renderEndDateField();
    renderHighlighterBar('duration');
  });

  $('#duration').on('input', function() {
    renderEndDateField();
    renderHighlighterBar('duration');
  });
  /* These two listeners should be kept in sync */

  $('#hourSelect').on('change', function() {
    renderDurationField();
  });

  $('input[type=submit]').on('click', function() {

    var resource_list = '';

    $('.fc-resource-area [data-resource-id]').each(function() {
      resource_id = $(this).attr('data-resource-id');
      unselected_background_color = 'rgba(0, 0, 0, 0)';
      selected = ($(this).find('.fc-widget-content').css('background-color') != unselected_background_color);
      if(selected) {
        resource_list += resource_id + "\n";
      }
    });

    alert(
      "Event will be created:\n" +
      "Start    :" + $.trim($("#start_date").val()) + "\n" +
      "End      :" + $.trim($("#end_date").val()) + "\n" +
      "Resources:\n" +
      resource_list
    );

    // //Passing mdate and phone variables to rails controller(book_date & phone)
    // window.open("localhost:3000//controller/create?mdate="+mdate+"&phone="+phone,"_self")
    //
    // -- OR --
    //
    // /* Send the data using post and put the results in a div */
    // $.ajax({
    //   url: "/BookCreate/?mdate="+mdate+"&phone="+phone,
    //   type: "post",
    //   data: values,
    //   success: function(){
    //     alert('Saved Successfully');
    //   },
    //   error:function(){
    //     alert('Error');
    //   }
    // });

  });

});

function setLocaleCode(localeCode) {
  $.datetimepicker.setLocale(localeCode);
  $('#fullcalendar_scheduler').fullCalendar('option', 'locale', localeCode);
}

function getEventWindowHeight() {
  var eventWindowHeightRegion = $('#fullcalendar_scheduler tbody.fc-body td.fc-time-area div.fc-scroller');
  return eventWindowHeightRegion.height()
}
function getEventWindowWidth() {
  var eventWindowWidthRegion = $('#fullcalendar_scheduler tbody.fc-body td.fc-time-area div.fc-scroller-canvas');
  return eventWindowWidthRegion.width();
}

function getEventWindowHours() {
  var eventWindowHours;
  var view = $('#fullcalendar_scheduler').fullCalendar('getView');
  var start = view.intervalStart;
  var end = view.intervalEnd;
  var days = end.diff(start, "days");
  return (24 * days);
}
