require_dependency "resource_planner/application_controller"

module ResourcePlanner
  class EventsController < ApplicationController
    before_action :set_event, only: [:show, :edit, :update, :destroy]

    # GET /events
    def index
      @events = ::ResourcePlanner::Event.events

      if false
      @month = (params[:month] || (Time.zone || Time).now.month).to_i
      @year = (params[:year] || (Time.zone || Time).now.year).to_i
      @shown_month = Date.civil(@year, @month)
      @event_strips = Event.event_strips_for_month(@shown_month)
      end

      respond_to do |format|
        #format.html # index.html.erb
        format.html { render ('index.' + ( params[:view].nil? ? '' : "#{params[:view]}." ) + 'html.erb') }
        format.xml  { render :xml => @events }
        #format.json # index.json.jbuilder
        format.json { render :json => @events }
      end
    end

    # GET /events/1
    def show
      respond_to do |format|
        format.html # show.html.erb
        #format.html { render ('show.' + ( params[:view].nil? ? '' : "#{params[:view]}." ) + 'html.erb') }
        format.xml  { render :xml => @event }
        format.json { render :json => @event }
      end
    end

    # GET /events/new
    def new
      @view = params[:view]
      @event = ::ResourcePlanner::Event.new
    end

    # GET /events/1/edit
    def edit
    end

    # POST /events
    def create
      @event = ::ResourcePlanner::Event.new(event_params)

      if @event.save
        format.html { redirect_to @event, notice: 'Event was successfully created.' }
        format.xml  { render :xml => @event, :status => :created, :location => @event }
        format.json { render :json => @event, :status => :created, :location => @event }
      else
        format.html { render :new }
        format.xml  { render :xml => @event.errors, :status => :unprocessable_entity }
        format.json { render :json => @event.errors, :status => :unprocessable_entity }
      end
    end

    # PATCH/PUT /events/1
    def update
      if @event.update(event_params)
        format.html { redirect_to @event, notice: 'Event was successfully updated.' }
        format.xml  { head :ok }
        format.json { head :no_content }
      else
        format.html { render :edit }
        format.xml  { render :xml => @event.errors, :status => :unprocessable_entity }
        format.json { render :json => @event.errors, :status => :unprocessable_entity }
      end
    end

    # DELETE /events/1
    def destroy
      @event.destroy

      respond_to do |format|
        format.html { redirect_to events_url, notice: 'Event was successfully destroyed.' }
        format.xml  { head :ok }
        format.json { head :no_content }
      end
    end

    private
      # Use callbacks to share common setup or constraints between actions.
      def set_event
        @event = ::ResourcePlanner::Event.find(params[:id])
      end

      # Only allow a trusted parameter "white list" through.
      def event_params
        params.fetch(:event, {})
      end

  end
end
