json.array!(@events) do |event|
  date_format = event.all_day? ? '%Y-%m-%d' : '%Y-%m-%dT%H:%M:%S'

  json.extract! event, :id
  json.id event.id
  json.title event.name
  json.description event.description
  json.start event.start_at.strftime(date_format)
  json.end event.end_at.strftime(date_format)
  json.url event_url(event, :format => :json)

  json.rendering 'background'

  resource_ids = Array.new
  event.event_subscriptions.each do |event_subscription|
    resource_ids.push( "#{event_subscription.resource_type}-#{event_subscription.resource.id}")
  end
  json.resourceIds resource_ids
end
